/* sparc64-linux-gcc-wrapper.c: a wrapper to set -m64 options for gcc
 *
 * Copyright (c) 1999 by Ben Collins <bcollins@debian.org>
 *
 * Licensed under the GNU GPL version 2 or later
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define GCC_SPARC_LINUX "/usr/bin/gcc"

int main (int argc, char *argv[], char *envp[])
{
    int i;
    char **newargs;

    newargs = (char **) calloc ((size_t) (argc + 3), sizeof(char *));
    if (newargs == NULL) {
	fprintf (stderr, "%s: error mallocing space for args\n", argv[0]);
	fprintf (stderr, "(note, this is not a gcc bug)\n");
	exit(1);
    }
    newargs[0] = argv[0];
    newargs[1] = "-m64";

    for ( i = 1 ; i < argc ; i++ ) {
	if (strcmp(argv[i], "-mmedlow") == 0)
	    newargs[i+1] = "-mcmodel=medlow";
	else
	    newargs[i+1] = argv[i];
    }

    newargs[i+1] = NULL;

    execve (GCC_SPARC_LINUX, newargs, envp);

    fprintf (stderr, "%s: error executing %s\n", argv[0], GCC_SPARC_LINUX);
    fprintf (stderr, "(note, this is not a gcc bug)\n");
    exit(1);
}
